SystemOrganization addCategory: #'GT-Window-EventRecorder'!
SystemOrganization addCategory: 'GT-Window-EventRecorder-Base'!
SystemOrganization addCategory: 'GT-Window-EventRecorder-Events'!

!WindowActivated methodsFor: '*GT-Window-EventRecorder' stamp: 'RogerStebler 6/16/2016 15:03'!
asRecorderEvent

	^ GTWindowRecorderWindowActivatedEvent fromAnnouncement: self! !

!TickingSpecWindow methodsFor: '*GT-Window-EventRecorder' stamp: 'RogerStebler 6/16/2016 14:43'!
eventRecorderWindowType

	^ super eventRecorderWindowType model ifNil: [ self ]! !

!WindowOpened methodsFor: '*GT-Window-EventRecorder' stamp: 'RogerStebler 6/16/2016 15:04'!
asRecorderEvent

	^ GTWindowRecorderWindowOpenedEvent fromAnnouncement: self! !

!SpecWindow methodsFor: '*GT-Window-EventRecorder' stamp: 'RogerStebler 6/16/2016 14:44'!
eventRecorderWindowType

	^ super eventRecorderWindowType model ifNil: [ self ]! !

!WindowClosed methodsFor: '*GT-Window-EventRecorder' stamp: 'RogerStebler 6/16/2016 15:03'!
asRecorderEvent

	^ GTWindowRecorderWindowClosedEvent fromAnnouncement: self! !

!WindowDeActivated methodsFor: '*GT-Window-EventRecorder' stamp: 'RogerStebler 6/16/2016 15:03'!
asRecorderEvent

	^ GTWindowRecorderWindowDeActivatedEvent fromAnnouncement: self! !

!WindowLabelled methodsFor: '*GT-Window-EventRecorder' stamp: 'RogerStebler 6/16/2016 15:04'!
asRecorderEvent

	^ GTWindowRecorderWindowLabelledEvent fromAnnouncement: self! !

GTEventCollector subclass: #GTWindowEventCollector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Window-EventRecorder-Base'!

GTWindowEventCollector class
	instanceVariableNames: 'uniqueInstance'!

!GTWindowEventCollector commentStamp: 'RogerStebler 5/2/2016 16:06' prior: 0!
I represent a GTEventCollector for windows.!

GTWindowEventCollector class
	instanceVariableNames: 'uniqueInstance'!

!GTWindowEventCollector class methodsFor: 'cleanup' stamp: 'RogerStebler 5/3/2016 14:15'!
cleanUp
	self reset! !

!GTWindowEventCollector class methodsFor: 'accessing' stamp: 'RogerStebler 6/17/2016 14:45'!
commonWindowTypes

	^ #( NautilusUI
		GTPlayground
		TestRunner
		MCWorkingCopyBrowser
		FinderUI
		VersionnerSpecBrowser
		DAPackageDependenciesWelcome
		ThreadSafeTranscript
		TimeProfiler
		SelectPackageBrowser
		ProcessBrowser
		FileList
		MessageBrowser
		DualChangeSorterApplication
		ExternalChangesBrowser
		PPBrowser
		CommandShellTranscript
		AboutDialogWindow
		SettingBrowser
		GTSpecPreDebugWindow
		GTGenericStackDebugger
		GTInspector
		SystemReporter
		KeymapBrowser
		TimeProfiler
		HelpBrowser
		FileDialogWindow ).! !

!GTWindowEventCollector class methodsFor: 'as yet unclassified' stamp: 'RogerStebler 6/29/2016 17:23'!
initialize

	Privacy sendDiagnosticsAndUsageData
		ifTrue: [ self uniqueInstance registerToWorldAnnouncements ]! !

GTWindowEventCollector initialize!

!GTWindowEventCollector class methodsFor: 'instance creation' stamp: 'RogerStebler 6/29/2016 17:32'!
reset
	uniqueInstance ifNotNil: [
		uniqueInstance unregisterToWorldAnnouncements.
		uniqueInstance := nil ].
	self initialize.! !

!GTWindowEventCollector class methodsFor: 'instance creation' stamp: 'AndreiChis 6/28/2016 11:12'!
uniqueInstance
	^ uniqueInstance ifNil: [
		uniqueInstance := self new ]! !

!GTWindowEventCollector methodsFor: 'initialization' stamp: 'RogerStebler 6/30/2016 16:07'!
initialize
	super initialize.	
	recordedEvents := WaitfreeQueue new.
	
	SystemAnnouncer uniqueInstance weak subscribe: PrivacyChangedAnnoucement
		send: #privacyChanged 
		to: self.! !

!GTWindowEventCollector methodsFor: 'announcement registration' stamp: 'RogerStebler 6/29/2016 17:21'!
privacyChanged
	Privacy sendDiagnosticsAndUsageData
		ifTrue: [ self registerToWorldAnnouncements ]
		ifFalse: [ self unregisterToWorldAnnouncements ]! !

!GTWindowEventCollector methodsFor: 'initialization' stamp: 'RogerStebler 5/2/2016 16:12'!
recordAnnouncement: anAnnouncement
	| event |
	Privacy sendDiagnosticsAndUsageData ifFalse: [ ^ self ].
	(anAnnouncement respondsTo: #asRecorderEvent) ifTrue: [	
		event := anAnnouncement asRecorderEvent.
		self add: event.
		GTEventRecorder uniqueInstance announcer announce: (GTWindowRecorderEventRecorded forEvent: event). ]! !

!GTWindowEventCollector methodsFor: 'announcement registration' stamp: 'RogerStebler 6/16/2016 15:01'!
registerToWindowAnnouncementsFor: aWindow

	^ aWindow announcer
		when: WindowActivated send: #windowActivated: to: self;
		when: WindowDeActivated send: #windowDeActivated: to: self;
		when: WindowCollapsed send: #windowCollapsed: to: self;
		when: WindowExpanded send: #windowExpanded: to: self;
		when: WindowLabelled send: #windowLabelled: to: self;
		when: WindowMoved send: #windowMoved: to: self.! !

!GTWindowEventCollector methodsFor: 'announcement registration' stamp: 'RogerStebler 5/2/2016 15:21'!
registerToWorldAnnouncements

	World announcer unsubscribe: self.
	
	World announcer weak
		when: WindowOpened send: #windowOpened: to: self;
		when: WindowClosed send: #windowClosed: to: self.! !

!GTWindowEventCollector methodsFor: 'announcement registration' stamp: 'RogerStebler 5/2/2016 15:26'!
unregisterToWindowAnnouncementsFor: aWindow

	^ aWindow announcer unsubscribe: self.! !

!GTWindowEventCollector methodsFor: 'announcement registration' stamp: 'RogerStebler 5/2/2016 15:21'!
unregisterToWorldAnnouncements

	World announcer unsubscribe: self! !

!GTWindowEventCollector methodsFor: 'annuncements' stamp: 'RogerStebler 5/2/2016 16:29'!
windowActivated: anAnnouncement

	self recordAnnouncement: anAnnouncement! !

!GTWindowEventCollector methodsFor: 'annuncements' stamp: 'RogerStebler 5/2/2016 16:29'!
windowClosed: anAnnouncement

	self recordAnnouncement: anAnnouncement.
	self unregisterToWindowAnnouncementsFor: anAnnouncement window! !

!GTWindowEventCollector methodsFor: 'annuncements' stamp: 'RogerStebler 6/16/2016 14:59'!
windowCollapsed: anAnnouncement

	self recordAnnouncement: anAnnouncement! !

!GTWindowEventCollector methodsFor: 'annuncements' stamp: 'RogerStebler 5/2/2016 16:29'!
windowDeActivated: anAnnouncement

	self recordAnnouncement: anAnnouncement! !

!GTWindowEventCollector methodsFor: 'annuncements' stamp: 'RogerStebler 6/16/2016 14:59'!
windowExpanded: anAnnouncement

	self recordAnnouncement: anAnnouncement! !

!GTWindowEventCollector methodsFor: 'annuncements' stamp: 'RogerStebler 6/16/2016 14:59'!
windowLabelled: anAnnouncement

	self recordAnnouncement: anAnnouncement! !

!GTWindowEventCollector methodsFor: 'annuncements' stamp: 'RogerStebler 6/16/2016 14:59'!
windowMoved: anAnnouncement

	self recordAnnouncement: anAnnouncement! !

!GTWindowEventCollector methodsFor: 'annuncements' stamp: 'RogerStebler 5/2/2016 16:29'!
windowOpened: anAnnouncement

	self recordAnnouncement: anAnnouncement.
	self registerToWindowAnnouncementsFor: anAnnouncement window! !

!WindowAnnouncement methodsFor: '*GT-Window-EventRecorder' stamp: 'RogerStebler 5/2/2016 16:16'!
asRecorderEvent

	^ GTWindowRecorderEvent fromAnnouncement: self! !

Announcement subclass: #GTWindowRecorderEventRecorded
	instanceVariableNames: 'recordedEvent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Window-EventRecorder-Base'!

!GTWindowRecorderEventRecorded commentStamp: 'RogerStebler 5/2/2016 16:12' prior: 0!
I am an event that is sent after a window action was recorded.!

!GTWindowRecorderEventRecorded class methodsFor: 'instance creation' stamp: 'RogerStebler 5/2/2016 16:11'!
forEvent: aRecorderEvent
	^ self new
		recordedEvent: aRecorderEvent;
		yourself.! !

!GTWindowRecorderEventRecorded methodsFor: 'accessing' stamp: 'RogerStebler 5/2/2016 16:11'!
recordedEvent
	^ recordedEvent! !

!GTWindowRecorderEventRecorded methodsFor: 'accessing' stamp: 'RogerStebler 5/2/2016 16:11'!
recordedEvent: aRecorderEvent
	recordedEvent := aRecorderEvent! !

!WindowMoved methodsFor: '*GT-Window-EventRecorder' stamp: 'RogerStebler 6/16/2016 15:04'!
asRecorderEvent

	^ GTWindowRecorderWindowMovedEvent fromAnnouncement: self! !

!SystemWindow methodsFor: '*GT-Window-EventRecorder' stamp: 'RogerStebler 6/16/2016 14:44'!
eventRecorderWindowType

	^ model ifNil: [ self ]! !

GTBasicRecorderEvent subclass: #GTWindowRecorderEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Window-EventRecorder-Events'!

!GTWindowRecorderEvent commentStamp: 'RogerStebler 5/2/2016 16:05' prior: 0!
I represent usage data generated by windows. 
All events have a timestamp.!

!GTWindowRecorderEvent class methodsFor: 'instance creation' stamp: 'RogerStebler 5/2/2016 15:43'!
fromAnnouncement: anAnnouncement

	^ self new fromAnnouncement: anAnnouncement! !

!GTWindowRecorderEvent methodsFor: 'initialization' stamp: 'RogerStebler 6/17/2016 14:56'!
addTypeFor: anAnnouncement
	| type |

	type := anAnnouncement window eventRecorderWindowType class name.
	
	(GTWindowEventCollector commonWindowTypes includes: type)
		ifTrue: [ self infoAt: #type put: type ]
		ifFalse: [ self infoAt: #type putHashForText: type ]! !

!GTWindowRecorderEvent methodsFor: 'initialization' stamp: 'RogerStebler 6/17/2016 14:56'!
fromAnnouncement: anAnnouncement
	
	self addTypeFor: anAnnouncement.
	self infoAt: #label putHashForText: anAnnouncement window label.
	self infoAt: #windowHash put: anAnnouncement window identityHash.! !

!GTWindowRecorderEvent methodsFor: 'testing' stamp: 'RogerStebler 6/16/2016 15:09'!
isWindowActivated

	^ false! !

!GTWindowRecorderEvent methodsFor: 'testing' stamp: 'RogerStebler 6/16/2016 15:09'!
isWindowClosed
	^ false! !

!GTWindowRecorderEvent methodsFor: 'testing' stamp: 'RogerStebler 6/16/2016 15:10'!
isWindowCollapsed
	^ false! !

!GTWindowRecorderEvent methodsFor: 'testing' stamp: 'RogerStebler 6/16/2016 15:11'!
isWindowDeActivated
	^ false! !

!GTWindowRecorderEvent methodsFor: 'testing' stamp: 'RogerStebler 6/16/2016 15:11'!
isWindowExpanded
	^ false! !

!GTWindowRecorderEvent methodsFor: 'testing' stamp: 'RogerStebler 6/16/2016 15:12'!
isWindowLabelled
	^ false! !

!GTWindowRecorderEvent methodsFor: 'testing' stamp: 'RogerStebler 6/16/2016 15:13'!
isWindowOpened
	^ false! !

!GTWindowRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 6/27/2016 15:44'!
label

	^ self infoAt: #label! !

!GTWindowRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 6/27/2016 15:44'!
windowHash

	^ self infoAt: #windowHash! !

!GTWindowRecorderEvent methodsFor: 'accessing' stamp: 'RogerStebler 6/27/2016 15:47'!
windowType

	^ self infoAt: #type! !

GTWindowRecorderEvent subclass: #GTWindowRecorderWindowActivatedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Window-EventRecorder-Events'!

!GTWindowRecorderWindowActivatedEvent commentStamp: 'RogerStebler 6/16/2016 15:16' prior: 0!
I represent the action when a window is activated.

Corresponding window announcement:
WindowActivated!

!GTWindowRecorderWindowActivatedEvent methodsFor: 'testing' stamp: 'RogerStebler 6/16/2016 15:09'!
isWindowActivated
	^ true! !

GTWindowRecorderEvent subclass: #GTWindowRecorderWindowClosedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Window-EventRecorder-Events'!

!GTWindowRecorderWindowClosedEvent commentStamp: 'RogerStebler 6/16/2016 15:17' prior: 0!
I represent the action when a window is closed.

Corresponding window announcement:
WindowClosed!

!GTWindowRecorderWindowClosedEvent methodsFor: 'testing' stamp: 'RogerStebler 6/16/2016 15:10'!
isWindowClosed
	^ true! !

GTWindowRecorderEvent subclass: #GTWindowRecorderWindowCollapsedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Window-EventRecorder-Events'!

!GTWindowRecorderWindowCollapsedEvent commentStamp: 'RogerStebler 6/16/2016 15:17' prior: 0!
I represent the action when a window is collapsed.

Corresponding window announcement:
WindowCollapsed!

!GTWindowRecorderWindowCollapsedEvent methodsFor: 'testing' stamp: 'RogerStebler 6/16/2016 15:10'!
isWindowCollapsed
	^ true! !

GTWindowRecorderEvent subclass: #GTWindowRecorderWindowDeActivatedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Window-EventRecorder-Events'!

!GTWindowRecorderWindowDeActivatedEvent commentStamp: 'RogerStebler 6/16/2016 15:17' prior: 0!
I represent the action when a window is deactivated.

Corresponding window announcement:
WindowDeActivated!

!GTWindowRecorderWindowDeActivatedEvent methodsFor: 'testing' stamp: 'RogerStebler 6/16/2016 15:11'!
isWindowDeActivated
	^ true! !

GTWindowRecorderEvent subclass: #GTWindowRecorderWindowExpandedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Window-EventRecorder-Events'!

!GTWindowRecorderWindowExpandedEvent commentStamp: 'RogerStebler 6/16/2016 15:17' prior: 0!
I represent the action when a window is expanded.

Corresponding window announcement:
WindowExpanded!

!GTWindowRecorderWindowExpandedEvent methodsFor: 'testing' stamp: 'RogerStebler 6/16/2016 15:11'!
isWindowExpanded
	^ true! !

GTWindowRecorderEvent subclass: #GTWindowRecorderWindowLabelledEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Window-EventRecorder-Events'!

!GTWindowRecorderWindowLabelledEvent commentStamp: 'RogerStebler 6/16/2016 15:17' prior: 0!
I represent the action when a window is labelled.

Corresponding window announcement:
WindowLabelled!

!GTWindowRecorderWindowLabelledEvent methodsFor: 'initialization' stamp: 'RogerStebler 6/27/2016 15:46'!
fromAnnouncement: anAnnouncement
	
	super fromAnnouncement: anAnnouncement.
	self infoAt: #newLabel putHashForText: anAnnouncement label.! !

!GTWindowRecorderWindowLabelledEvent methodsFor: 'testing' stamp: 'RogerStebler 6/16/2016 15:12'!
isWindowLabelled
	^ true! !

!GTWindowRecorderWindowLabelledEvent methodsFor: 'accessing' stamp: 'RogerStebler 6/27/2016 15:46'!
newLabel

	^ self infoAt: #newLabel! !

GTWindowRecorderEvent subclass: #GTWindowRecorderWindowMovedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Window-EventRecorder-Events'!

!GTWindowRecorderWindowMovedEvent commentStamp: 'RogerStebler 6/16/2016 15:17' prior: 0!
I represent the action when a window is moved.

Corresponding window announcement:
WindowMoved!

!GTWindowRecorderWindowMovedEvent methodsFor: 'initialization' stamp: 'RogerStebler 6/16/2016 15:25'!
fromAnnouncement: anAnnouncement
	
	super fromAnnouncement: anAnnouncement.
	self infoAt: #oldPosition put: anAnnouncement oldPosition.
	self infoAt: #newPosition put: anAnnouncement newPosition.! !

!GTWindowRecorderWindowMovedEvent methodsFor: 'testing' stamp: 'RogerStebler 6/16/2016 15:12'!
isWindowMoved
	^ true! !

!GTWindowRecorderWindowMovedEvent methodsFor: 'accessing' stamp: 'RogerStebler 6/16/2016 15:27'!
newPosition
	^ self infoAt: #newPosition! !

!GTWindowRecorderWindowMovedEvent methodsFor: 'accessing' stamp: 'RogerStebler 6/16/2016 15:27'!
oldPosition
	^ self infoAt: #oldPosition! !

GTWindowRecorderEvent subclass: #GTWindowRecorderWindowOpenedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Window-EventRecorder-Events'!

!GTWindowRecorderWindowOpenedEvent commentStamp: 'RogerStebler 6/16/2016 15:18' prior: 0!
I represent the action when a window is opened.

Corresponding window announcement:
WindowOpened!

!GTWindowRecorderWindowOpenedEvent methodsFor: 'testing' stamp: 'RogerStebler 6/16/2016 15:13'!
isWindowOpened
	^ true! !

!WindowExpanded methodsFor: '*GT-Window-EventRecorder' stamp: 'RogerStebler 6/16/2016 15:03'!
asRecorderEvent

	^ GTWindowRecorderWindowExpandedEvent fromAnnouncement: self! !

!WindowCollapsed methodsFor: '*GT-Window-EventRecorder' stamp: 'RogerStebler 6/16/2016 15:03'!
asRecorderEvent

	^ GTWindowRecorderWindowCollapsedEvent fromAnnouncement: self! !

GTWindowEventCollector initialize!
